﻿namespace SampleProject
{
    using Infragistics.Win.UltraWinGrid;
    using System.Windows.Forms;
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.ultraGrid1.AfterSelectChange += UltraGrid1_AfterSelectChange;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            SummarySettings ss = this.ultraGrid1.DisplayLayout.Bands[0].Summaries.Add(SummaryType.Sum, this.ultraGrid1.DisplayLayout.Bands[0].Columns["Price"]);
            ss.SummaryType = SummaryType.Custom;
            ss.CustomSummaryCalculator = new SummaryCalculator();            
        }

        private void UltraGrid1_AfterSelectChange(object sender, AfterSelectChangeEventArgs e)
        {
            UltraGrid grid = (UltraGrid)sender;
            grid.DisplayLayout.Bands[0].Summaries[0].Refresh();
        }
    }

    public class SummaryCalculator : ICustomSummaryCalculator
    {
        private double total = 0;

        // Begins the summary for the SummarySettings object passed in. 
        public void BeginCustomSummary(SummarySettings settings, RowsCollection rows)
        {
            this.total = 0;
        }

        // Process each row that gets passed in
        public void AggregateCustomSummary(SummarySettings settings, UltraGridRow row)
        {
            if (row.Selected)
            {
                string cellValue = row.GetCellText(settings.SourceColumn);
                    
                double val = 0;
                if (double.TryParse(cellValue, out val))
                    this.total += val;
            }
        }

        // Return the calculated summary value
        public object EndCustomSummary(SummarySettings settings, RowsCollection rows)
        {
            return this.total;
        }
    }
}
